;Last update : 2015.03.27
;Tested AHK v1.1.20.02
; need GDI class : http://ahkscript.org/boards/viewtopic.php?f=6&t=5820

#Include CGdi.ahk
#SingleInstance Off
#NoTrayIcon
#NoEnv
program_ver = 1.0
program_title = Pixel Picker v%program_ver%
ZoomerUpdateSpeed = 100 ; default screen update speed.
CoordMode, Pixel, Screen

pixelCount  := 11
pixelSize := 30
sx := 4, sy := 4   ;Pixel Button Gui Start point.
pixelCount := (pixelCount//2*2=pixelCount)? pixelCount+1 : pixelCount
pixelRangePattern := GetPixelRangePatternArray(pixelCount)
centerPixel := pixelCount//2 + 1
mouseOnBtn_x := mouseOnBtn_y := centerPixel
copyFormat_org := "[%x%,%y%] %colormode% %color%" "|Add(%color%,%x%,%y%)|{x:%x%,y:%y%} %delimiter%, %%"

;Pixel GUI Access v Var : vPixel%x%_%y%
Gui, Margin, 3,2
Gui, +LastFound
program_handle := WinExist()
WinGet, pm_handle, ID, Program Manager
loop % pixelCount
{
  yindex := A_index
  y := sy + pixelSize * (yindex - 1)
  loop % pixelCount
  {
    xindex := A_index
    x := sx + pixelSize * (xindex - 1)
    Gui, Add, Progress, % "x" x " y" y " w" pixelSize " h" pixelSize " vPixel" xindex "_" yindex " hwndhwnd" xindex "_" yindex
  }
}
;Center Pixel highright.
GuiControl, Move, % "Pixel" centerPixel "_" centerPixel, % "w" pixelSize-1 " h" pixelSize-1
;
win_width := pixelCount * pixelSize
Gui, Add, Text, xm w320 vTextXYColor
Gui, Add, Checkbox, xm xp+3 yp+18 w130 gCheckZoomerHold vCheckZoomerHold, Zoomer Hold (F1)
Gui, Add, Checkbox, xp+140 w50 gCheckRGB vCheckRGB, RGB
Gui, Add, Checkbox, xp+110 w80 gCheckAntiGuard vCheckAntiGuard, AntiGuard
Gui, Add, Link, xm yp+18 w50 gBtnHelp, <a id="1">Help</a>
Gui, Add, Link, xp+90 w50 gBtnReload, <a id="1">Reload</a>
Gui, Add, Link, xp+90 w50 gBtnClear, <a id="1">Clear</a>
Gui, Add, Link, xp+80 w70 vBtnCopy gBtnCopy Right, <a id="1">Copy (F2)</a>
Gui, Add, ComboBox, xm yp+18 w%win_width% vListCopyFormat
Gui, Show,, %program_title%
Gui, +AlwaysOnTop +ToolWindow

;create pixel button.
PixelButton := {}
loop % pixelCount
{
  if !IsObject(PixelButton[x := A_index])
    PixelButton[x] := {}
  loop % pixelCount
    PixelButton[x][A_index] := new CCustomButton(hwnd%x%_%A_index%)
}

;Reg Msg Handler
OnMessage(0x00F, "WM_PAINT")
OnMessage(0x200, "WM_MOUSEMOVE")
OnMessage(0x201, "WM_LBUTTONDOWN")
OnMessage(0x202, "WM_LBUTTONUP")

Gosub, CheckZoomerHold
Gosub, IniLoad
SetTimer, HotkeyManager, 200
Return

GuiEscape:
GuiClose:
ExitApp

BtnHelp:
  str =
  (LTrim
    Pixel Marking  =  'Ctrl' + 'LButtonClick'
    Move Offset    =  'Ctrl' + ' or  or  or '
  )
  MsgBox,4096, Help, %str%
return

IniLoad:
  copyFormat_list := ""
  iniFile := RegExReplace(A_ScriptName, ".exe|.ahk") ".ini"
  loop
  {
    IniRead, read, %iniFile%, CopyFormat, %A_index%, -1
    if (read=-1)
      break
    copyFormat_list .= "|" read
  }
  StringReplace, copyFormat_list, copyFormat_list, |
  if !copyFormat_list
  {
    copyFormat_list := copyFormat_org
    StringSplit, list, copyFormat_list, |
    loop % list0
      IniWrite, % list%A_index%, %iniFile%, CopyFormat, %A_index%
  }
  GuiControl,, ListCopyFormat, |%copyFormat_list%
  GuiControl, Choose, ListCopyFormat, 1
return
;--------------------------------------------------------------------------------

~LButton::
return

^UP::
    x := 0 , y := -1
    Goto, ArrowKey
return
^Down::
    x := 0 , y := 1
    Goto, ArrowKey
return
^Left::
    x := -1 , y := -0
    Goto, ArrowKey
return
^Right::
    x := 1 , y := 0
    Goto, ArrowKey
return
ArrowKey:
  if CheckZoomerHold
    offsetmovex := x , offsetmovey := y
  else
    MouseMove, x,y,, R
return

F1::
  GuiControl,, CheckZoomerHold, % !CheckZoomerHold
CheckZoomerHold:
  GuiControlGet, CheckZoomerHold
  SetTimer, Zoomer_Move, % CheckZoomerHold? "Off" : ZoomerUpdateSpeed
  SetTimer, Zoomer_Hold, % CheckZoomerHold? ZoomerUpdateSpeed : "Off"
  ToolTip
return

CheckRGB:
  GuiControlGet, CheckRGB
  UpdateRGBState()
return

CheckAntiGuard:
  GuiControlGet, CheckAntiGuard
return

BtnReload:
  GuiControlGet, list,, ListCopyFormat
  Gosub, IniLoad
  GuiControl, ChooseString, ListCopyFormat, % list
  UpdatePixelButtons()
return

BtnClear:
  for, x, xline in PixelButton
  for, y, btn in xline
    btn.check := "" , btn.Default()
return

F2::
BtnCopy:
  ;%x%,%y%=%colormode% %color%
  GuiControlGet, format,, ListCopyFormat
  if !CheckZoomerHold
    Clipboard := GetFormatString(format, centerx, centery, centercolor).string
  else
  {
    delimiter := "`r`n"
    Clipboard := str := ""
    for, x, xline in PixelButton
    for, y, btn in xline
    if (btn.check)
    {
      obj := GetFormatString(format, x-1, y-1, btn.GetColor(), btn.check)
      str .= obj.string . (delimiter := obj.delimiter? obj.delimiter:"`r`n")
    }
    Clipboard := Trim(str, delimiter)
  }
return

;--------------------------------------------------------------------------------
Zoomer_Move:
  MouseGetPos, centerx,centery, mouseHwnd
  if (program_handle==mouseHwnd)
    return
  WinGet, hwnd, ID, A
  WinGetPos, ax,ay,,, ahk_id %hwnd%
  centerx += ax, centery += ay  ;get coordinate of screen
  UpdatePixelButtons(centerx, centery)

  WinGetPos, mx,my,,, ahk_id %mouseHwnd%
  if CheckAntiGuard
    centercolor := PixelGetColor(centerx, centery, CheckRGB)
  else
    PixelGetColor, centercolor, centerx, centery, % CheckRGB? "rgb":""
  centerx -= mx, centery -= my
  TextXYColor := "[x=" centerx ", y=" centery "] " (CheckRGB? "RGB":"GRB") " " centercolor
  if (TextXYColor<>oldTextXYColor)
    GuiControl,, TextXYColor, % oldTextXYColor := TextXYColor
return

Zoomer_Hold:
  if offsetmovex or offsetmovey
  {
    UpdatePixelButtons(offsetmovex, offsetmovey, "offset")
    offsetmovex := offsetmovey := 0
  }
  color := PixelButton[mouseOnBtn_x][mouseOnBtn_y].GetColor()
  TextXYColor := "[" mouseOnBtn_x-1 ", " mouseOnBtn_y-1 "] " (CheckRGB? "RGB":"GRB") " " color
  if (TextXYColor<>oldTextXYColor)
    GuiControl,, TextXYColor, % oldTextXYColor := TextXYColor
return

HotkeyManager:
  hotkey_list = F1|F2|^Left|^Right|^Up|^Down
  WinGet, hwnd, ID, A
  WinGetClass, class, ahk_id %hwnd%
  WinGetTitle, title, ahk_id %hwnd%
  if (class="AutoHotkeyGUI") and (title=program_title)
  loop, parse, hotkey_list, |
    Hotkey, %A_LoopField%, % (hwnd=program_handle)? "On":"Off"
return

;--------------------------------------------------------------------------------
;Set color to Pixel Button
;option = offset :  lastx += centerx , lasty += centery
UpdatePixelButtons(centerx="", centery="", option="")
{
  global PixelButton, pixelRangePattern, CheckRGB, CheckAntiGuard, pm_handle
  static lastx, lasty
  if (centerx<>"") and (option="")
  {
    lastx := centerx
    lasty := centery
  }
  else
  {
    if option=offset
      lastx += centerx , lasty += centery
    centerx := lastx
    centery := lasty
    IfWinNotActive, ahk_id %pm_handle%
    {
      WinActivate, ahk_id %pm_handle%
      sleep, 100
    }
  }
  for, ix, xline in PixelButton
  {
    rx := pixelRangePattern[ix] + centerx
    for, iy, btn in xline
    {
      ry := pixelRangePattern[iy] + centery
      if CheckAntiGuard
        color := PixelGetColor(rx, ry, CheckRGB)
      else
        PixelGetColor, color, rx, ry
      btn.SetColor(color)
      btn.rgb := CheckRGB
    }
  }
}

;--------------------------------------------------------------------------------
UpdateRGBState()
{
  global PixelButton, CheckRGB
  for, x, xline in PixelButton
  for, y, btn in xline
    btn.rgb := CheckRGB
}

;--------------------------------------------------------------------------------
GetPixelRangePatternArray(pixelCount)
{
  obj := {}
  center := pixelCount//2 + 1
  loop % pixelCount
    obj[A_index] := A_index - center
  return obj
}

;--------------------------------------------------------------------------------
GetInvertColor(color)
{
  oldFormat := A_FormatInteger
  SetFormat, integer, Hex
  color += 0
  StringReplace, color, color, 0x
  loop % 6 - strlen(color)
    color := "0" color
  inv = 0x
  loop 3
  {
    StringMid, c, color, % A_index*2-1, 2
    c := "0x" c , c := 0xff - c
    StringReplace, c, c, 0x
    inv .= !c? "00" : (strlen(c)=1)? ("0" c) : c
  }
  SetFormat, integer, % oldFormat
  return inv
}

;--------------------------------------------------------------------------------
;make to string of copy. apply to copy format string.
GetFormatString(format, x,y, color, buttonCheck="")
{
  global CheckRGB
  ;ex) %x%,%y%=%colormode% %color%
  ;ex) Add(%color%,%x%,%y%) %delimiter%,%%
  StringReplace, format, format, % "%x%", % x, All
  StringReplace, format, format, % "%y%", % y, All
  StringReplace, format, format, % "%colormode%", % CheckRGB? "RGB":"GRB", All
  StringReplace, format, format, % "%color%", % color, All
  IfInString, format, % "%delimiter%"
  if RegExMatch(format, "%delimiter%(.*)%%", delimiter)
  {
    StringReplace, format, format, % "%delimiter%" delimiter1 "%%"
    StringReplace, delimiter1, delimiter1, "`r", `r
    StringReplace, delimiter1, delimiter1, "`n", `n
  }
  format := Trim(format)
  return {string:format, delimiter:delimiter1}
}

;--------------------------------------------------------------------------------
WM_PAINT()
{
  global PixelButton
  for, x, xline in PixelButton
  for, y, btn in xline
    btn.WM_PAINT()
}

WM_MOUSEMOVE(wParam, lParam, Msg, hWnd)
{
  global PixelButton, mouseOnBtn_x, mouseOnBtn_y
  for, x, xline in PixelButton
  for, y, btn in xline
    if btn.WM_MOUSEMOVE(wParam, lParam, Msg, hWnd)
      mouseOnBtn_x := x , mouseOnBtn_y := y
}

WM_LBUTTONDOWN(wParam, lParam, Msg, hWnd)
{
  global PixelButton
  for, x, xline in PixelButton
  for, y, btn in xline
    btn.WM_LBUTTONDOWN(wParam, lParam, Msg, hWnd)
  GuiControl, focus, TextXYColor
}

WM_LBUTTONUP(wParam, lParam, Msg, hWnd)
{
  global PixelButton, CheckZoomerHold, CheckRGB
  for, x, xline in PixelButton
  for, y, btn in xline
    if btn.WM_LBUTTONUP(wParam, lParam, Msg, hWnd)
      click := {x:x, y:y}
  if CheckZoomerHold
  if click
  {
    ToolTip, % "[" click.x-1 "," click.y-1 "] " (CheckRGB?"RGB":"GRB") " " PixelButton[click.x][click.y].GetColor()
    GuiControlGet, ListCopyFormat
    Clipboard := GetFormatString(ListCopyFormat, click.x-1, click.y-1, PixelButton[click.x][click.y].GetColor()).string
  }
  else
    ToolTip
}

;--------------------------------------------------------------------------------
;x,y coordinate is screen axis.
PixelGetColor(X, Y, RGB=0)
{
  chdc:= CreateCompatibleDC(), hbm := CreateDIBSection(1, 1, chdc), obm := SelectObject(chdc, hbm), hhdc:= hhdc ? hhdc : GetDC()
  BitBlt(chdc, 0, 0, 1, 1, hhdc, X, Y, 0x40000000 | 0x00CC0020)
  
  ;return value ARGB format
  DllCall("GetBitmapBits", UInt, hbm, UInt, VarSetCapacity(bits,4,0), UInt,&bits)
  oldf := A_FormatInteger
  SetFormat, Integer, H
  color := NumGet(bits,0, 4) & 0x00FFFFFF
  if !RGB
    color := ((0xFF0000 & color) >> 16) | ((0x00FF00 & color)) | ((0x0000FF & color) << 16)
  SetFormat, Integer, % oldF
  ReleaseDC(hhdc), SelectObject(chdc, obm), DeleteObject(hbm), DeleteDC(hhdc), DeleteDC(chdc)
  StringReplace, color, color, 0x
  loop % 6-strlen(color)
    color := "0" color
  return "0x" color
}

;--------------------------------------------------------------------------------
;Part function of GDIP.ahk
;--------------------------------------------------------------------------------
CreateDIBSection(w, h, hdc="", bpp=32, ByRef ppvBits=0)
{
  hdc2 := hdc ? hdc : GetDC()
  VarSetCapacity(bi, 40, 0)
  NumPut(w, bi, 4), NumPut(h, bi, 8), NumPut(40, bi, 0), NumPut(1, bi, 12, "ushort"), NumPut(0, bi, 16), NumPut(bpp, bi, 14, "ushort")
  hbm := DllCall("CreateDIBSection", "uint" , hdc2, "uint" , &bi, "uint" , 0, "uint*", ppvBits, "uint" , 0, "uint" , 0)
  if !hdc
  ReleaseDC(hdc2)
  return hbm
}

GetDC(hwnd=0)
{
  return DllCall("GetDC", "uint", hwnd)
}

SelectObject(hdc, hgdiobj)
{
  return DllCall("SelectObject", "uint", hdc, "uint", hgdiobj)
}

DeleteObject(hObject)
{
   return DllCall("DeleteObject", "uint", hObject)
}

DeleteDC(hdc)
{
   return DllCall("DeleteDC", "uint", hdc)
}

CreateCompatibleDC(hdc=0)
{
  return DllCall("CreateCompatibleDC", "uint", hdc)
}

BitBlt(ddc, dx, dy, dw, dh, sdc, sx, sy, Raster="")
{
  return DllCall("gdi32\BitBlt", "uint", dDC, "int", dx, "int", dy, "int", dw, "int", dh
  , "uint", sDC, "int", sx, "int", sy, "uint", Raster ? Raster : 0x00CC0020)
}

ReleaseDC(hdc, hwnd=0)
{
   return DllCall("ReleaseDC", "uint", hwnd, "uint", hdc)
}


;--------------------------------------------------------------------------------------------
; This is Custom Button use GDI class. Thank you 'GeekDude'.
;--------------------------------------------------------------------------------------------
class CCustomButton
{
  static checkMark := ""
  __New(hWnd)
  {
    this.check := ""
    this.GDI := new CGDI(hWnd)
    this.hWnd := hWnd
    this.SetColor(0xFFFFFF)
  }
  
  SetColor(color)
  {
    if (this.color<>color)
      this.Draw(this.color := color, 0x000000)
  }
  GetColor()
  {
    oldFormat := A_FormatInteger
    SetFormat, integer, Hex
    color := this.color + 0
    SetFormat, integer, % oldFormat
    StringReplace, color, color, 0x
    loop % 6 - strlen(color)
      color := "0" color
    if this.rgb
    {
      StringMid, left, color, 1,2
      StringMid, mid, color, 3,2
      StringMid, right, color, 5,2
      return "0x" right mid left
    }
    return "0x" color
  }
  
  Default()
  {
    this.Draw(this.color, 0x000000)
  }
  
  Hovering()
  {
    this.Draw(this.color, 0xffffff)
  }
  
  Held()
  {
    this.Draw(this.color, 0x0000FF)
  }
  
  Draw(Color, BorderColor)
  {
    critical
    this.GDI.FillRectangle(0, 0, this.GDI.CliWidth, this.GDI.CliHeight, Color, BorderColor)
    if this.check
      this.GDI.DrawText(0, 0, this.GDI.CliWidth, this.GDI.CliHeight, this.check, GetInvertColor(this.color), "Courier New", 20, "CC")
    this.GDI.BitBlt()
  }
  
  BitBlt()
  {
    this.GDI.BitBlt()
  }

  ;-----------------------------------------
  WM_PAINT()
  {
    Sleep, -1 ; Let the scrollbar redraw before painting over it
    this.BitBlt()
  }

  WM_MOUSEMOVE(wParam, lParam, Msg, hWnd)
  {
    if (hWnd != this.LasthWnd)
    {
      if (hWnd == this.hWnd)
        this.Hovering()
      else if (this.lasthWnd == this.hWnd)
        this.Default()
      this.lasthWnd := hwnd
      if (hWnd == this.hWnd)
        return 1
    }
  }
  
  WM_LBUTTONDOWN(wParam, lParam, Msg, hWnd)
  {
    if (hWnd == this.hWnd)
    {
      this.Held()
      this.click := 1
      if GetKeyState("Ctrl")
        this.ctrl := 1
    }
  }
  
  WM_LBUTTONUP(wParam, lParam, Msg, hWnd)
  {
    if (hWnd == this.hWnd)
    {
      if this.click
        if GetKeyState("Ctrl")
          this.check := this.check? "":this.checkMark
      this.Hovering()
      if this.click
        return 1 , this.click := 0
    }
    this.click := 0
  }
}

